LeetCode11: Container With Most Water

Two pointer~

1. Description

  • Given n non-negative integers a1, a2, …, an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

在这里插入图片描述

  • The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49

2. Two pointer~

参考:Solution

class Solution {
public:
    int maxArea(vector<int>& height) {
        int area = 0;
        int first = 0;
        int end = height.size() - 1; 
        while (first < end){
            area = max(min(height[first], height[end]) * (end - first), area);
            if (height[first] < height[end])
                first++;
            else 
                end--;
        }
        return area;
        
    }
};

在这里插入图片描述
注意:

  1. 木桶盛水的容量取决于最短的那个长度。 这里使用2 pointer法
问题:为什么height[first] < height[end], 让first ++ ,也就是让first右移?

当左端线段L小于右端线段R时,我们把L右移,这时舍弃的是L与右端其他线段(R-1, R-2, …)组成的木桶,这些木桶是没必要判断的,因为这些木桶的容积肯定都没有L和R组成的木桶容积大。如果高的移动的话,因为一方面高度没有变化(因为取决于最短的木板)而且下标也会变短。

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值